;******************* Constants ***********************


;************** ASM file header stuff ***************

	include	"tios.h"
	xdef	_library
	xdef	lzsslib@0000
	xdef	lzsslib@0001

;*****************************************
;* Allocate memory for unpacked data and *
;* then call the decoder                 *
;*  Input: a0.l = Ptr to source data     *
;* Output: d1.w = Handle of dest data    *
;*         a1.l = Ptr to dest data       *
;*****************************************
lzsslib@0000:
extract:
	movem.l		d0/d2/a0/a2,-(sp)

	move.w		(a0),-(sp)		;Get size of extracted file
	clr.w		-(sp)			;tio::HeapAlloc neads a longword
	jsr		tios::HeapAlloc		;Allocate space for unpacked data
	addq.l		#4,sp
	move.l		d0,d1
	beq.s		\nomem

	tios::DEREF	d0,a1
	move.l		8(sp),a0
	bsr		extract_to

\nomem	movem.l		(sp)+,d0/d2/a0/a2
	rts

;************************************
;* LZSS decoder                     *
;* Input: a0.l = Ptr to source data *
;*        a1.l = Ptr to destination *
;************************************
lzsslib@0001:
extract_to:
	movem.l		a0-a6/d0-d7,-(sp)

	move.w		(a0)+,d0	;Unpacked filesize
	lea		0(a1,d0.w),a6	;End adress of file

	move.b		(a0)+,d5	;Max MatchLength descriptor bitsize
	move.b		(a0)+,(a1)+	;First byte is never coded. NOTE: This gets us to an even adress!

	moveq		#2,d7		;MaxDistance
	lea		1(a1),a4	;MaxDistance limit adress
	moveq		#1,d6		;MaxDistanceBits

	moveq		#0,d1		;Start bit (zero so that the algorithm grabs the first byte for us).

\loop	cmp.l		a4,a1
	ble.s		\nxtdta		;Distance is still within limits?
	lea		0(a4,d7.w),a4	;Increase MaxDistance limit adress to double it's former value
	lsl.w		#1,d7		;Double next MaxDistance increase
	addq.w		#1,d6		;and increase MaxDistanceBits

\nxtdta	dbra		d1,\gotbit	;Next bit
	moveq		#7,d1		;Bit became < 0, reset bit to 7
	move.b		(a0)+,d0	;and read next byte
\gotbit	lsl.b		#1,d0		;Check next bit. If zero, we have a byte, if one, we have a reference
	bcc.s		\char

;Data is a reference, get distance and length
	move.w		d6,d2
	bsr		readbits	;Read Distance-1 into d3
	not.w		d3		;Data is always to the left (HAS BEEN NEG.W)
	lea		0(a1,d3.w),a5	;Get starting adress of data (note that: "not.w d3" = "(neg.w d3) - 1")
;NOTE: We don't "not.w" back d3 because we test bits in it later...











;* THIS CODE IS A CPU HOG!!! *

	move.w		d6,d2		;Get number of bits we might require to describe the length
\glloop	btst.b		d2,d3
	dbeq		d2,\glloop	;My first try with this kind of loop structure...
\glfnd	addq.w		#1,d2
	beq.s		\glfnd		;Can't have zero bits (if the loop runs out d2=-1 and then d2=(-1)+1...)

	cmp.b		d5,d2
	ble.s		\isok		;Required bits are lower than MaxMatchLength, use calculated value
	move.b		d5,d2		;Required bits exceed MaxMatchLength, use that instead
\isok







	bsr		readbits	;Read the length of the data

\cploop	move.b		(a5)+,(a1)+	;Copy byte by byte
	dbra		d3,\cploop	;the referenced data
	bra.s		\next

;Data is a character, just get one and continue
\char	bsr		readbyte	;Read 8 bits
	move.b		d3,(a1)+	;Place them on out OutBuffer

;Any characters left?
\next	cmp.l		a6,a1		;Are we at the end adress yet?
	blt		\loop		;If not, continue


	movem.l		(sp)+,a0-a6/d0-d7
	rts

;**************************************
;* Read d2 bits and put value in d3.l *
;**************************************
readbits:
	moveq		#0,d3
	subq.w		#1,d2
\nxtbit	dbra		d1,\gotbit	;Next bit
	moveq		#7,d1		;Bit became < 0, reset bit to 7
	move.b		(a0)+,d0	;and read next byte
\gotbit	lsl.b		#1,d0		;Rotate next bit into the X flag
	roxl.l		#1,d3		;and rotate it into the lowest bit of the returned value...
	dbra		d2,\nxtbit
\done	rts

;******************************************
;* Read eight bits and place them in d3.b *
;******************************************
readbyte:
	move.b		d0,d3
	move.b		(a0)+,d0	;New byte
	ror.w		d1,d0
	or.b		d0,d3
	lsr.w		#8,d0
	rts

;********************** Variables **************************

;***************************** Byte stuff *******************************

;************** End of Fargo program ****************

_library:	dc.b	"lzsslib",0

;*****************************************************

	end
